addHook("PlayerThink", function(player)
	if (player.playerstate == PST_LIVE) and not (player.powers[pw_carry])
		player.jumpfactor = skins[player.mo.skin].jumpfactor
		if (player.pflags & PF_JUMPED and player.pflags & PF_THOKKED and ((player.mo.state == S_PLAY_JUMP and not (player.charflags & SF_NOJUMPSPIN)) or player.mo.state == S_PLAY_ROLL or (player.mo.skin == "espio" and player.mo.state == S_ESPIO_ROLL) or (player.mo.skin == "bomb" and (player.mo.state == S_BOMB_TOPSPIN or player.mo.state == S_BOMB_TOPSPIN_FAST))))
			if (player.mo.skin == "mighty" and not (player.pflags & PF_SHIELDABILITY) and player.mo.state != S_PLAY_JUMP)
				player.mo.state = S_PLAY_JUMP
				player.pflags = $ | PF_JUMPED
				player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
				if (player.cmd.forwardmove or player.cmd.sidemove)
					if not (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
					elseif (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 18*FRACUNIT)
					elseif not (player.mo.eflags & MFE_UNDERWATER) and (player.powers[pw_super] or player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					elseif (player.mo.eflags & MFE_UNDERWATER and (player.powers[pw_super] or player.powers[pw_sneakers]))
						P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
					end
				end
			elseif (player.mo.skin != "bomb")
				player.pflags = $ | PF_SPINNING | PF_THOKKED
			elseif (player.mo.skin == "bomb")
				player.pflags = $ | PF_JUMPED
				player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
			end
		elseif (player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH)
			if (player.pflags & PF_JUMPED and not (player.pflags & PF_THOKKED and player.mo.state == S_PLAY_JUMP) and player.mo.skin != "heavy")
				player.pflags = $ & ~(PF_SPINNING|PF_THOKKED)
			elseif not (player.mo.skin == "heavy" and P_IsObjectOnGround(player.mo))
				player.pflags = $ | PF_THOKKED
			end
			if (player.mo.skin == "vector" and player.cmd.buttons & BT_SPIN)
				player.normalspeed = skins[player.mo.skin].normalspeed
			else
				player.normalspeed = 0
			end
			if (P_IsObjectOnGround(player.mo))
				if (player.cmd.forwardmove or player.cmd.sidemove)
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(FRACUNIT/4))
				else
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(FRACUNIT/2))
				end
			end
		elseif ((player.powers[pw_sneakers] or player.powers[pw_super]) and player.mo.skin != "heavy")
			if (player.mo.skin == "espio" and player.mo.state == S_PLAY_CLIMB)
				player.normalspeed = 7*skins[player.mo.skin].normalspeed/20
			else
				player.normalspeed = skins[player.mo.skin].normalspeed
			end
			if (player.powers[pw_super])
				player.runspeed = 29*(36*FRACUNIT)/32
			elseif (player.powers[pw_sneakers])
				player.runspeed = 29*(60*FRACUNIT)/32
			end
		else
			if (player.mo.skin == "espio" and player.mo.state == S_PLAY_CLIMB)
				player.normalspeed = 7*skins[player.mo.skin].normalspeed/12
			else
				player.normalspeed = skins[player.mo.skin].normalspeed
			end
			if (player.mo.skin == "heavy")
				player.runspeed = 24*FRACUNIT
			else
				player.runspeed = 29*(36*FRACUNIT)/32
			end
		end
		if (player.powers[pw_justlaunched] and not (player.pflags & PF_SPINNING))
			player.pflags = $ & ~PF_THOKKED
		end
		if (player.mo.skin == "sonic" or player.mo.skin == "tails" or player.mo.skin == "knuckles" or player.mo.skin == "metalsonic" or player.mo.skin == "mighty" or player.mo.skin == "ray" or player.mo.skin == "espio" or player.mo.skin == "charmy" or player.mo.skin == "vector" or player.mo.skin == "bomb")
			if not (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
				player.mindash = 36*FRACUNIT
				player.maxdash = 72*FRACUNIT
			elseif not (player.mo.eflags & MFE_UNDERWATER) and (player.powers[pw_super] or player.powers[pw_sneakers])
				player.mindash = 60*FRACUNIT
				player.maxdash = 72*FRACUNIT
			elseif (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
				player.mindash = 18*FRACUNIT
				player.maxdash = 72*FRACUNIT
			elseif (player.mo.eflags & MFE_UNDERWATER) and (player.powers[pw_super] or player.powers[pw_sneakers])
				player.mindash = 30*FRACUNIT
				player.maxdash = 72*FRACUNIT
			end
		end
		if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.cmd.forwardmove or player.cmd.sidemove) and not (player.pflags & PF_SPINNING) and not (player.skidtime) and player.mo.state != S_PLAY_MELEE_LANDING and player.mo.state != S_PLAY_BOUNCE_LANDING and player.mo.skin != "heavy")
			if ((not (player.powers[pw_super]) and player.speed > player.runspeed) or (player.powers[pw_super] and player.speed > 5*player.runspeed/3))
				player.mo.friction = FRACUNIT
				P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), -(FRACUNIT/4))
			elseif ((not (player.powers[pw_super]) and player.speed <= player.runspeed) or (player.powers[pw_super] and player.speed <= 5*player.runspeed/3))
				player.mo.friction = 29*FRACUNIT/32
			end
		elseif (player.mo.skin == "heavy" or not ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.cmd.forwardmove or player.cmd.sidemove) and not (player.pflags & PF_SPINNING) and not (player.skidtime)))
			player.mo.friction = 29*(FRACUNIT)/32
		end
		if (player.mo.skin != "heavy" and player.pflags & PF_JUMPED and ((player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP) or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING)))
			player.pflags = $ | PF_NOJUMPDAMAGE
		elseif not (player.mo.skin != "heavy" and player.pflags & PF_JUMPED and ((player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP) or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING))) and (player.pflags & PF_JUMPED)
			player.pflags = $ & ~PF_NOJUMPDAMAGE
		end
		if not (P_IsObjectOnGround(player.mo)) and ((player.charflags & SF_NOJUMPSPIN and player.mo.state == S_PLAY_JUMP) or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or (player.mo.skin == "mighty" and player.mo.state == S_MIGHTY_HAMMERDROP_SPRING) or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_SKID or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_EDGE or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_DASH) and not ((player.mo.skin == "sonic" or player.mo.skin == "metalsonic") and player.secondjump)
			player.pflags = $ | PF_JUMPED | PF_NOJUMPDAMAGE
			if ((player.mo.momz*P_MobjFlip(player.mo) > 0) and player.mo.state != S_PLAY_SPRING)
				player.mo.state = S_PLAY_SPRING
			elseif ((player.mo.momz*P_MobjFlip(player.mo) <= 0) and player.mo.state != S_PLAY_FALL)
				player.mo.state = S_PLAY_FALL
			end
			if (player.mo.skin == "amy" or player.mo.skin == "bomb")
				player.pflags = $ & ~PF_THOKKED
			end
		end
		if (((player.mo.skin == "sonic" and player.pflags & PF_THOKKED and not (player.secondjump == 1 and player.cmd.buttons & BT_SPIN)) or player.pflags & PF_SHIELDABILITY) and not (P_IsObjectOnGround(player.mo)))
			if (player.mo.state != S_PLAY_JUMP and not (player.charflags & SF_NOJUMPSPIN))
				player.mo.state = S_PLAY_JUMP
			elseif (player.mo.state != S_PLAY_ROLL and player.charflags & SF_NOJUMPSPIN)
				player.mo.state = S_PLAY_ROLL
			end
		end
		if (player.mo.skin == "sonic")
			if (player.secondjump and not (player.cmd.buttons & BT_SPIN) and not (P_IsObjectOnGround(player.mo)))
				player.pflags = $ | PF_JUMPED | PF_THOKKED
				player.pflags = $ & ~PF_SPINNING
				player.secondjump = 0
			end
			if (P_IsObjectOnGround(player.mo) and not (player.pflags & PF_SPINNING))
				player.pflags = $ & ~PF_THOKKED
			end
		end
		if (player.mo.skin == "tails")
			if (player.cmd.buttons & BT_JUMP and player.cmd.buttons & BT_SPIN and (not (P_IsObjectOnGround(player.mo)) and (player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_FLY_TIRED or player.mo.state == S_PLAY_SWIM)))
				player.mo.state = S_PLAY_JUMP
				player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
				player.pflags = $ & ~PF_NOJUMPDAMAGE
			end
			if (player.cmd.buttons & BT_JUMP and (not (P_IsObjectOnGround(player.mo)) and (player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_FLY_TIRED or player.mo.state == S_PLAY_SWIM)))
				player.fly1 = 1
			end
			if (player.powers[pw_tailsfly] > 2*TICRATE and not (player.powers[pw_super]))
				player.powers[pw_tailsfly] = 2*TICRATE
			end
		end
		if (player.mo.skin == "knuckles")
			if player.momentumplusglidelast == nil
				player.momentumplusglidelast = 0
			end
			local gliding = player.pflags & PF_GLIDING
			local thokked = player.pflags & PF_THOKKED
			local exitglide = (player.momentumplusglidelast == 1 and not (gliding) and thokked)
			local landglide = (player.momentumplusglidelast == 2 and not (gliding|thokked))
			if ((exitglide or landglide) and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_GLIDE_LANDING))
				player.mo.momx = $*2
				player.mo.momy = $*2
				if (exitglide)
					if (player.mo.state != S_PLAY_JUMP)
						player.mo.state = S_PLAY_JUMP
						player.mo.momz = $/2
					end
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
					player.pflags = $ & ~(PF_NOJUMPDAMAGE|PF_GLIDING)
				end
			end
			if (P_IsObjectOnGround(player.mo) and player.pflags & PF_GLIDING)
				player.mo.state = S_PLAY_GLIDE_LANDING
				S_StartSound(player.mo, sfx_s3k4c)
				player.pflags = $ & ~PF_GLIDING
				player.skidtime = 0
			end
			if gliding
				player.momentumplusglidelast = 1
			elseif exitglide
				player.momentumplusglidelast = 2
			elseif not(gliding|thokked)
				player.momentumplusglidelast = 0
			end
		end
		if (player.mo.skin == "amy")
			if (player.powers[pw_super])
				player.thokitem = MT_LHRT
				player.revitem = MT_LHRT
			else
				player.thokitem = MT_NULL
				player.revitem = MT_NULL
			end
			if (player.mo.state == S_PLAY_MELEE or player.mo.state == S_PLAY_MELEE_FINISH or player.mo.state == S_PLAY_TWINSPIN)
				player.charability2 = CA2_MELEE
			else
				player.charability2 = CA2_NONE
			end
			if (player.cmd.buttons & BT_SPIN and not (player.plusbuttons & BT_SPIN) and player.mo.state != S_PLAY_MELEE and player.mo.state != S_PLAY_MELEE_FINISH and player.mo.state != S_PLAY_MELEE_LANDING and player.mo.state != S_PLAY_SUPER_TRANS1 and player.mo.state != S_PLAY_SUPER_TRANS2 and player.mo.state != S_PLAY_SUPER_TRANS3 and player.mo.state != S_PLAY_SUPER_TRANS4 and player.mo.state != S_PLAY_SUPER_TRANS5 and player.mo.state != S_PLAY_SUPER_TRANS6)
				P_ResetPlayer(player)
				player.pflags = $|PF_THOKKED
				player.pflags = $ & ~(PF_SPINNING|PF_JUMPED)
				player.mo.state = S_PLAY_MELEE
				player.powers[pw_strong] = STR_MELEE
				player.drawangle = player.mo.angle
				player.skidtime = 0
				S_StartSound(player.mo, sfx_s3k42)
				if P_IsObjectOnGround(player.mo)
					player.mo.z = $+P_MobjFlip(player.mo)
					P_SetObjectMomZ(player.mo, player.mindash, false)
					if (P_MobjFlip(player.mo)*player.mo.pmomz < 0)
						player.mo.momz = $+player.mo.pmomz
					elseif (P_MobjFlip(player.mo)*player.mo.pmomz >= 0)
						player.mo.pmomz = 0
					end
				elseif not (P_IsObjectOnGround(player.mo))
					player.mo.z = $-P_MobjFlip(player.mo)
					P_SetObjectMomZ(player.mo, -(player.mindash), false)
					if (P_MobjFlip(player.mo)*player.mo.pmomz < 0)
						player.mo.momz = $-player.mo.pmomz
					elseif (P_MobjFlip(player.mo)*player.mo.pmomz >= 0)
						player.mo.pmomz = 0
					end
				end
				if (player.cmd.forwardmove or player.cmd.sidemove)
					if (player.powers[pw_super] or player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
						if (player.speed < 60*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
						elseif (player.speed >= 60*FRACUNIT and player.speed <= 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, player.speed+(6*FRACUNIT))
						elseif (player.speed > 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 72*FRACUNIT)
						end
					elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and not (player.mo.eflags & MFE_UNDERWATER)
						if (player.speed < 36*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
						elseif (player.speed >= 36*FRACUNIT and player.speed <= 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, player.speed+(6*FRACUNIT))
						elseif (player.speed > 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 72*FRACUNIT)
						end
					elseif (player.powers[pw_super] or player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
						if (player.speed < 30*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
						elseif (player.speed >= 30*FRACUNIT and player.speed <= 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, player.speed+(6*FRACUNIT))
						elseif (player.speed > 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 72*FRACUNIT)
						end
					elseif not (player.powers[pw_super]) and not (player.powers[pw_sneakers]) and (player.mo.eflags & MFE_UNDERWATER)
						if (player.speed < 18*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 18*FRACUNIT)
						elseif (player.speed >= 18*FRACUNIT and player.speed <= 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, player.speed+(6*FRACUNIT))
						elseif (player.speed > 72*FRACUNIT)
							P_InstaThrust(player.mo, player.mo.angle, 72*FRACUNIT)
						end
					end
				end
			end
			if (player.mo.state == S_PLAY_MELEE_LANDING)
				if (player.cmd.buttons & BT_SPIN and not (player.cmd.buttons & BT_JUMP) and player.speed > 5*FRACUNIT)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_SPINNING|PF_THOKKED
					S_StartSound(player.mo, sfx_spin)
				elseif (player.cmd.buttons & BT_JUMP and not (player.cmd.buttons & BT_SPIN))
					P_DoJump(player, false)
					player.mo.state = S_PLAY_TWINSPIN
					player.powers[pw_strong] = STR_TWINSPIN
					player.pflags = $ & ~PF_SPINNING
					player.pflags = $ | PF_THOKKED
					S_StartSound(player.mo, sfx_jump)
					S_StartSound(player.mo, sfx_s3k42)
				else
					player.mo.state = S_PLAY_STND
					player.pflags = $ & ~PF_SPINNING|PF_THOKKED
				end
			end	
		end
		if (player.mo.skin == "fang")
			local fanglockon = P_LookForEnemies(player, false, true)
			local fangbullet = nil
			local fangbomb = nil
			if (fanglockon and fanglockon.valid)
				P_SpawnLockOn(player, fanglockon, mobjinfo[MT_LOCKON].spawnstate)
			end
			if player.momentumplusbouncelast == nil
				player.momentumplusbouncelast = false
			end
			if ((player.pflags & PF_BOUNCING and not (player.momentumplusbouncelast)) or (not (player.pflags & PF_BOUNCING) and player.momentumplusbouncelast) and (player.mo.state == S_PLAY_BOUNCE or player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL))
				player.mo.momx = $*2
				player.mo.momy = $*2
				if (not (player.pflags & PF_BOUNCING) and player.momentumplusbouncelast and player.mo.state != S_PLAY_ROLL)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED|PF_THOKKED
					player.pflags = $ & ~(PF_NOJUMPDAMAGE|PF_BOUNCING)
				end
			end
			if (player.cmd.buttons & BT_USE and not (player.plusbuttons & BT_USE) and not (player.weapondelay) and player.mo.state != S_PLAY_FIRE and player.mo.state != S_PLAY_FIRE_FINISH and (P_IsObjectOnGround(player.mo) or player.pflags & PF_JUMPED or (player.pflags & PF_SPINNING and player.pflags & PF_THOKKED and not (player.pflags & PF_JUMPED))) and player.mo.state != S_PLAY_SUPER_TRANS1 and player.mo.state != S_PLAY_SUPER_TRANS2 and player.mo.state != S_PLAY_SUPER_TRANS3 and player.mo.state != S_PLAY_SUPER_TRANS4 and player.mo.state != S_PLAY_SUPER_TRANS5 and player.mo.state != S_PLAY_SUPER_TRANS6 and not (player.pflags & PF_JUMPED and player.pflags & PF_THOKKED and player.pflags & PF_SPINNING))
				player.mo.state = S_PLAY_FIRE
				player.pflags = $|PF_SPINDOWN
				player.pflags = $ & ~(PF_SPINNING|PF_THOKKED|PF_BOUNCING)
				if (player.powers[pw_super])
					player.weapondelay = 6
				else
					player.weapondelay = TICRATE/2
				end
				if not (P_IsObjectOnGround(player.mo))
					player.mo.momz = $/2
				end
				if (fanglockon and fanglockon.valid)
					player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, fanglockon.x, fanglockon.y)
					fangbullet = P_SpawnPointMissile(player.mo, fanglockon.x, fanglockon.y, fanglockon.z, player.revitem, player.mo.x, player.mo.y, player.mo.z)
				end
				if not (fanglockon and fanglockon.valid)
					fangbullet = P_SpawnPointMissile(player.mo, player.mo.x + P_ReturnThrustX(nil, player.mo.angle, FRACUNIT), player.mo.y + P_ReturnThrustY(nil, player.mo.angle, FRACUNIT), player.mo.z, player.revitem, player.mo.x, player.mo.y, player.mo.z)
				end
			end
			if ((player.mo.state == S_PLAY_BOUNCE_LANDING or ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.pflags & PF_BOUNCING or player.momentumplusbouncelast))))
				if not (player.weapondelay)
					fangbomb = P_SpawnMobjFromMobj(player.mo,5*FRACUNIT,5*FRACUNIT,player.mo.height+5*FRACUNIT,MT_FBOMB)
					fangbomb.target = player.mo
					fangbomb.momz = 10*FRACUNIT
					player.weapondelay = TICRATE/2
					S_StartSound(player.mo, sfx_s3k51)
				end
				if (player.cmd.forwardmove or player.cmd.sidemove)
					if not (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
					elseif (player.mo.eflags & MFE_UNDERWATER) and not (player.powers[pw_super]) and not (player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 18*FRACUNIT)
					elseif not (player.mo.eflags & MFE_UNDERWATER) and (player.powers[pw_super] or player.powers[pw_sneakers])
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					elseif (player.mo.eflags & MFE_UNDERWATER and (player.powers[pw_super] or player.powers[pw_sneakers]))
						P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
					end
				end
			end
			if (player.mo.state == S_PLAY_FIRE or player.mo.state == S_PLAY_FIRE_FINISH)
				if (player.weapondelay)
					player.pflags = $|PF_JUMPSTASIS
				end
				if ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.cmd.buttons & BT_SPIN or player.plusbuttons & BT_SPIN) and player.speed > FixedMul(5<<FRACBITS, player.mo.scale)) and not (player.weapondelay) and not (player.cmd.buttons & BT_JUMP) and not (player.plusbuttons & BT_JUMP)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $ | PF_SPINNING
					player.pflags = $ & ~PF_STARTDASH
					S_StartSound(player.mo, sfx_spin)
				elseif ((P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and (player.cmd.buttons & BT_JUMP or player.plusbuttons & BT_JUMP)) and not (player.weapondelay) and not (player.cmd.buttons & BT_SPIN) and not (player.plusbuttons & BT_SPIN)
					P_DoJump(player, false)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED|PF_THOKKED
					S_StartSound(player.mo, sfx_jump)
				elseif (P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR) and not (player.weapondelay) and not (player.cmd.buttons & BT_SPIN) and not (player.plusbuttons & BT_SPIN) and not (player.cmd.buttons & BT_JUMP) and not (player.plusbuttons & BT_JUMP)
					player.mo.state = S_PLAY_STND
				elseif not (P_IsObjectOnGround(player.mo)) and not (player.weapondelay)
					player.mo.state = S_PLAY_ROLL
					player.pflags = $|PF_JUMPED|PF_THOKKED
					player.pflags = $ & ~(PF_NOJUMPDAMAGE|PF_BOUNCING)
				end
			end
		end
		if (player.mo.skin == "metalsonic")
			if (player.dashmode < TICRATE and player.mo.state != S_PLAY_SPINDASH)
				player.dashmode = TICRATE
			elseif (player.dashmode < 3*TICRATE and player.mo.state == S_PLAY_SPINDASH and P_IsObjectOnGround(player.mo) and not (player.mo.eflags & MFE_UNDERWATER))
				if not (maptol & TOL_NIGHTS)
					player.dashmode = 3*TICRATE
					S_StartSound(player.mo, sfx_kc4d)
				end
			end
			if (player.dashmode >= 3*TICRATE and player.mo.state != S_PLAY_SPINDASH and P_IsObjectOnGround(player.mo) and (player.cmd.forwardmove or player.cmd.sidemove))
				if (player.pflags & PF_SPINNING)
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), (FRACUNIT/4))
				else
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.rmomx, player.rmomy), (FRACUNIT/2))
				end
			end
			if (player.secondjump)
				player.pflags = $ | PF_JUMPED | PF_THOKKED
				player.secondjump = 2
				player.mo.flags = $ | MF_NOGRAVITY
				if (player.speed < player.runspeed)
					player.mo.state = S_PLAY_FLOAT
					player.pflags = $ | PF_NOJUMPDAMAGE
				elseif (player.speed >= player.runspeed and not (player.dashmode >= 3*TICRATE))
					player.mo.state = S_PLAY_FLOAT_RUN
					player.pflags = $ | PF_NOJUMPDAMAGE
				elseif (player.speed >= player.runspeed and player.dashmode >= 3*TICRATE)
					player.mo.state = S_PLAY_DASH
					player.pflags = $ & ~PF_NOJUMPDAMAGE
				end
				if (player.cmd.buttons & BT_JUMP and not (player.cmd.buttons & BT_SPIN))
					if P_MobjFlip(player.mo)*player.mo.momz < 5*FRACUNIT
						P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
					elseif P_MobjFlip(player.mo)*player.mo.momz > 5*FRACUNIT
						P_SetObjectMomZ(player.mo, -(FRACUNIT/2), true)
					end
				elseif (player.cmd.buttons & BT_SPIN and not (player.cmd.buttons & BT_JUMP))
					if P_MobjFlip(player.mo)*player.mo.momz > -(5*FRACUNIT)
						P_SetObjectMomZ(player.mo, -(FRACUNIT/2), true)
					elseif P_MobjFlip(player.mo)*player.mo.momz < -(5*FRACUNIT)
						P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
					end
				elseif (not (player.cmd.buttons & BT_JUMP) and not (player.cmd.buttons & BT_SPIN))
					if P_MobjFlip(player.mo)*player.mo.momz > 0
						P_SetObjectMomZ(player.mo, -(FRACUNIT/2), true)
					elseif P_MobjFlip(player.mo)*player.mo.momz < 0
						P_SetObjectMomZ(player.mo, FRACUNIT/2, true)
					end
				elseif (player.cmd.buttons & BT_JUMP and player.cmd.buttons & BT_SPIN)
					player.mo.state = S_PLAY_JUMP
					player.pflags = $|PF_JUMPED|PF_SPINNING|PF_THOKKED
					player.pflags = $ & ~PF_NOJUMPDAMAGE
					player.secondjump = 0
				end
			elseif not (player.secondjump)
				player.mo.flags = $ & ~MF_NOGRAVITY
			end
		end
		if (player.mo.skin == "heavy" and (player.pflags & PF_SPINNING or player.pflags & PF_STARTDASH) and player.mo.heavyvars.tics > 3)
			player.mo.heavyvars.tics = 3
		end
	end
	player.momentumplusbouncelast = (player.pflags & PF_BOUNCING > 0)
	player.plusbuttons = player.cmd.buttons
	player.pluslastspeed = player.speed
end)
addHook("MobjDamage", function(enemy, mo, source)
	if (mo and mo.valid) and not (P_IsObjectOnGround(mo)) and not (mo.eflags & MFE_JUSTHITFLOOR)
		if (enemy and enemy.valid) and (mo.state == S_PLAY_JUMP or mo.state == S_PLAY_SPRING or mo.state == S_PLAY_FALL or mo.state == S_PLAY_ROLL or (mo.skin == "espio" and mo.state == S_ESPIO_ROLL))
			mo.player.pflags = $ & ~(PF_THOKKED|PF_SHIELDABILITY)
		end
	end
end)
addHook("MobjDeath", function(enemy, mo, source)
	if (mo and mo.valid) and not (P_IsObjectOnGround(mo)) and not (mo.eflags & MFE_JUSTHITFLOOR)
		if (enemy and enemy.valid) and (mo.state == S_PLAY_JUMP or mo.state == S_PLAY_SPRING or mo.state == S_PLAY_FALL or mo.state == S_PLAY_ROLL or (mo.skin == "espio" and mo.state == S_ESPIO_ROLL))
			mo.player.pflags = $ & ~(PF_THOKKED|PF_SHIELDABILITY)
		end
	end
end)